#ifndef _OcclusionQuery_H__
#define _OcclusionQuery_H__

#include <vector>


namespace GtpVisibilityPreprocessor { 

/** This class is an implementation for occlusion queries.
	@remark the class encapsulates occlusion query calls.
*/
class OcclusionQuery
{
public:
	
	OcclusionQuery();

	virtual ~OcclusionQuery();

	virtual bool ResultAvailable() const;
	virtual unsigned int GetQueryResult() const;
	virtual void BeginQuery();
	virtual void EndQuery();
	
	static void GenQueries(std::vector<OcclusionQuery *> &queries, int numQueries);

	unsigned int GetQueryId() const;


protected:

	OcclusionQuery(const unsigned int idx);
	
	unsigned int mId;
};

} // namespace 
#endif // OcclusionQuery_H